<template>
  <v-menu
    v-model="dateMenu"
    :close-on-content-click="false"
    transition="scale-transition"
    offset-y="offset-y"
    max-width="290px"
    min-width="290px"
  ><template v-slot:activator="{ on }">
      <v-text-field
        v-bind="$attrs"
        v-model="dateFormatted"
        persistent-hint="persistent-hint"
        autocomplete='off'
        append-icon="mdi-calendar"
        v-mask="displayMask"
        v-on="on"
       />    </template>
    <v-date-picker
      v-model="date"
      no-title="no-title"
      @input="dateMenu = false"
     />  </v-menu>
</template>

<script lang="ts">
import Vue from 'vue'

import { DateTime } from 'luxon'

const displayFormat = 'dd/MM/yyyy'
const displayMask = '##/##/####'

export default Vue.extend({
  name: 'DateInput',
  props: {
    value: {
      type: String,
      default: null
    }
  },
  data: () => ({
    dateMenu: false,

    displayMask
  }),
  computed: {
    date: {
      get (): string {
        return this.value
      },
      set (v: string) {
        this.$emit('input', v)
      }
    },
    dateFormatted: {
      get () : string {
        if (!this.date) return ''
        return DateTime.fromISO(this.date).toFormat(displayFormat)
      },
      set (v: string) {
        if (v && v.length === 10) {
          this.date = DateTime.fromString(v, displayFormat).toISODate()
        }
      }
    }
  }
})
</script>
